diff -rupN newpd/pd-0.45-0/tcl/dialog_audio.tcl pd-0.45-0/tcl/dialog_audio.tcl
--- newpd/pd-0.45-0/tcl/dialog_audio.tcl	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/tcl/dialog_audio.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -7,6 +7,9 @@ namespace eval ::dialog_audio:: {
 # TODO this panel really needs some reworking, it works but the code is very
 # unreadable.  The panel could look a lot better too, like using menubuttons
 # instead of regular buttons with tk_popup for pulldown menus.
+# * make sure combobox is setting the device number
+# * get focus order to do right
+# * add "Close" button to prefs dialog
 
 ####################### audio dialog ##################3
 
@@ -19,6 +22,29 @@ proc ::dialog_audio::apply {mytoplevel}
     global audio_outenable1 audio_outenable2 audio_outenable3 audio_outenable4
     global audio_sr audio_advance audio_callback audio_blocksize
 
+    # Hackety hack! Rather than make this audio dialog code sane,
+    # which would be a larger project, I'm just making the user interface
+    # look more friendly. The global "enable" variables were used
+    # for checkbuttons; I simplified the interface by removing them and
+    # adding a "None" option to the device list.  This means I have
+    # to parse the dev names for the string "None" and set the "enable"
+    # variables accordingly. I also assume "None" is the last value in the
+    # list.
+
+    foreach type {in out} {
+        foreach i {1 2 3 4} {
+            if {[set audio_${type}dev${i}] == \
+                [llength [set ::audio_${type}devlist]] || 
+                [set audio_${type}chan${i}] <= 0} {
+                set audio_${type}dev${i} 0
+                set audio_${type}enable${i} 0
+                set audio_${type}chan${i} 0
+            } else {
+                set audio_${type}enable${i} 1
+            }
+        }
+    }
+
     pdsend "pd audio-dialog \
         $audio_indev1 \
         $audio_indev2 \
@@ -40,10 +66,34 @@ proc ::dialog_audio::apply {mytoplevel}
         $audio_advance \
         $audio_callback \
         $audio_blocksize"
+
+    # Pd always makes devices contiguous-- for example, if you only set
+    # device 1 and device 3 it will change device 3 to device 2.
+    # So we look for non-contiguous devices and request an update
+    # on connect so that the user doesn't see incorrect information
+    # in the GUI. This rebuilds part of the dialog window which causes
+    # a slight flicker-- otherwise I'd just do this everytime:
+    # pdsend "pd audio-properties $::audio_longform
+    foreach type {in out} {
+        set empty_dev 0
+        set aliased_dev 0
+        foreach i {1 2 3 4} {
+            set enabled [set audio_${type}enable$i]
+            if {$empty_dev && $enabled} {
+                set aliased_dev 1
+                break
+            } elseif {!$enabled} {incr empty_dev}
+        }
+        if {$aliased_dev} {
+            pdsend "pd audio-properties $::audio_longform"
+            break
+        }
+    }
+    pdsend "pd save-preferences"
 }
 
 proc ::dialog_audio::cancel {mytoplevel} {
-    pdsend "$mytoplevel cancel"
+#    pdsend "$mytoplevel cancel"
 }
 
 proc ::dialog_audio::ok {mytoplevel} {
@@ -51,26 +101,45 @@ proc ::dialog_audio::ok {mytoplevel} {
     ::dialog_audio::cancel $mytoplevel
 }
 
-# callback from popup menu
-proc audio_popup_action {buttonname varname devlist index} {
-    global audio_indevlist audio_outdevlist $varname
-    $buttonname configure -text [lindex $devlist $index]
-    set $varname $index
+proc ::dialog_audio::setapi {var - op} {
+    if {$op ne "write"} {return}
+    set name [set $var]
+    set index [lsearch -exact -index 0 $::audio_apilist $name]
+    set ::pd_whichapi [lindex $::audio_apilist $index 1]
+    pdsend "pd audio-setapi $::pd_whichapi"
 }
 
-# create a popup menu
-proc audio_popup {name buttonname varname devlist} {
-    if [winfo exists $name.popup] {destroy $name.popup}
-    menu $name.popup -tearoff false
-    if {$::windowingsystem eq "win32"} {
-        $name.popup configure -font menuFont
+proc ::dialog_audio::setlongform {widget} {
+    set state [set ::$widget]
+    if {$state == 0} {
+        # back to single devs
+        set extra_devs 0
+        foreach type {in out} {
+            foreach i {2 3 4} {
+                if { [set ::audio_${type}chan$i] > 0 &&
+                     [set ::audio_${type}enable$i] > 0 } {
+                          incr extra_devs
+                }
+            }
+        }
+        if {$extra_devs} {
+            set devices devices
+            if {$extra_devs == 1} {set devices device}
+            set continue [tk_messageBox -type yesno -message \
+                [_ "This will disconnect $extra_devs $devices. Continue?"] \
+                 -default "no" -parent [winfo parent $widget] -icon question]
+            if {$continue eq "yes"} {
+               foreach type {in out} {
+                   foreach i {2 3 4} {
+                       set ::audio_${type}chan$i 0
+                       set ::audio_${type}enable$i 0
+                   }
+               }
+            ::dialog_audio::apply [winfo parent $widget]
+            }
+        }
     }
-    for {set x 0} {$x<[llength $devlist]} {incr x} {
-        $name.popup add command -label [lindex $devlist $x] \
-            -command [list audio_popup_action \
-                          $buttonname $varname $devlist $x] 
-    }
-    tk_popup $name.popup [winfo pointerx $name] [winfo pointery $name] 0
+    pdsend "pd audio-properties $state"
 }
 
 # start a dialog window to select audio devices and settings.  "multi"
@@ -97,11 +166,6 @@ proc ::dialog_audio::pdtk_audio_dialog {
     global pd_indev pd_outdev
     global audio_longform
 
-    set audio_indev1 $indev1
-    set audio_indev2 $indev2
-    set audio_indev3 $indev3
-    set audio_indev4 $indev4
-
     set audio_inchan1 [expr ( $inchan1 > 0 ? $inchan1 : -$inchan1 ) ]
     set audio_inenable1 [expr $inchan1 > 0 ]
     set audio_inchan2 [expr ( $inchan2 > 0 ? $inchan2 : -$inchan2 ) ]
@@ -111,10 +175,15 @@ proc ::dialog_audio::pdtk_audio_dialog {
     set audio_inchan4 [expr ( $inchan4 > 0 ? $inchan4 : -$inchan4 ) ]
     set audio_inenable4 [expr $inchan4 > 0 ]
 
-    set audio_outdev1 $outdev1
-    set audio_outdev2 $outdev2
-    set audio_outdev3 $outdev3
-    set audio_outdev4 $outdev4
+    # "None" is added as the last value in the dropdown menu, so it's
+    # equivalent to the length of the devlist
+    set nonein [llength $audio_indevlist]
+    set noneout [llength $audio_outdevlist]
+
+    set audio_indev1 [expr ( $audio_inenable1 ? $indev1 : $nonein )]
+    set audio_indev2 [expr ( $audio_inenable2 ? $indev2 : $nonein )]
+    set audio_indev3 [expr ( $audio_inenable3 ? $indev3 : $nonein )]
+    set audio_indev4 [expr ( $audio_inenable4 ? $indev4 : $nonein )]
 
     set audio_outchan1 [expr ( $outchan1 > 0 ? $outchan1 : -$outchan1 ) ]
     set audio_outenable1 [expr $outchan1 > 0 ]
@@ -125,199 +194,159 @@ proc ::dialog_audio::pdtk_audio_dialog {
     set audio_outchan4 [expr ( $outchan4 > 0 ? $outchan4 : -$outchan4 ) ]
     set audio_outenable4 [expr $outchan4 > 0 ]
 
+    set audio_outdev1 [expr ( $audio_outenable1 ? $outdev1 : $noneout )]
+    set audio_outdev2 [expr ( $audio_outenable2 ? $outdev2 : $noneout )]
+    set audio_outdev3 [expr ( $audio_outenable3 ? $outdev3 : $noneout )]
+    set audio_outdev4 [expr ( $audio_outenable4 ? $outdev4 : $noneout )]
+
     set audio_sr $sr
     set audio_advance $advance
     set audio_callback $callback
     set audio_blocksize $blocksize
+    set audio_longform $longform
 
-    toplevel $mytoplevel -class DialogWindow
-    wm title $mytoplevel [_ "Audio Settings"]
-    wm group $mytoplevel .
-    wm resizable $mytoplevel 0 0
-    wm transient $mytoplevel
-    $mytoplevel configure -menu $::dialog_menubar
-    $mytoplevel configure -padx 10 -pady 5
-    ::pd_bindings::dialog_bindings $mytoplevel "audio"
-    # not all Tcl/Tk versions or platforms support -topmost, so catch the error
-    catch {wm attributes $mytoplevel -topmost 1}
-
-    frame $mytoplevel.buttonframe
-    pack $mytoplevel.buttonframe -side bottom -fill x -pady 2m
-    button $mytoplevel.buttonframe.cancel -text [_ "Cancel"]\
-        -command "::dialog_audio::cancel $mytoplevel"
-    pack $mytoplevel.buttonframe.cancel -side left -expand 1 -fill x -padx 15
-    button $mytoplevel.buttonframe.apply -text [_ "Apply"]\
-        -command "::dialog_audio::apply $mytoplevel"
-    pack $mytoplevel.buttonframe.apply -side left -expand 1 -fill x -padx 15
-    button $mytoplevel.buttonframe.ok -text [_ "OK"] \
-        -command "::dialog_audio::ok $mytoplevel"
-    pack $mytoplevel.buttonframe.ok -side left -expand 1 -fill x -padx 15
-
-    button $mytoplevel.saveall -text [_ "Save All Settings"]\
-        -command "::dialog_audio::apply $mytoplevel; pdsend {pd save-preferences}"
-    pack $mytoplevel.saveall -side bottom -expand 1 -pady 5
-    
-        # sample rate and advance
-    frame $mytoplevel.srf
-    pack $mytoplevel.srf -side top
-    
-    label $mytoplevel.srf.l1 -text [_ "Sample rate:"]
-    entry $mytoplevel.srf.x1 -textvariable audio_sr -width 7
-    label $mytoplevel.srf.l2 -text [_ "Delay (msec):"]
-    entry $mytoplevel.srf.x2 -textvariable audio_advance -width 4
-
-    label $mytoplevel.srf.l3 -text [_ "Block size:"]
-    tk_optionMenu $mytoplevel.srf.x3 audio_blocksize 64 128 256 512 1024 2048
-
-    pack $mytoplevel.srf.l1 $mytoplevel.srf.x1 $mytoplevel.srf.l2 \
-        $mytoplevel.srf.x2 $mytoplevel.srf.l3 $mytoplevel.srf.x3 -side left
+    set mytoplevel .prefs.nb.audio
+    set apifr $mytoplevel.api
+    if {![winfo exists $apifr]} {
+
+        # Audio API
+        ttk::labelframe $mytoplevel.api -text [_ "Audio API"] \
+            -style Prefs.TLabelframe
+        pack $apifr -side top -padx 1 -pady 1 -fill x
+        set api_names {}
+        set ::audio_apiname {};
+        foreach api $::audio_apilist {lappend api_names [lindex $api 0]}
+        set api_i [lsearch -exact -index 1 $::audio_apilist $::pd_whichapi]
+        set ::audio_apiname [lindex $::audio_apilist $api_i 0]
+        ::dialog_prefs::dropdown $apifr.apilist ::audio_apiname $api_names
+        trace add variable ::audio_apiname write ::dialog_audio::setapi
+        grid $apifr.apilist -sticky e -column 0 -row 0 -padx 3 -pady 10
+        ttk::checkbutton $apifr.longbutton -text "Use multiple devices" \
+            -command "::dialog_audio::setlongform $apifr.longbutton"
+        grid $apifr.longbutton -sticky w -column 1 -row 0 -padx 3 -pady 10
+        grid columnconfigure $apifr {0 1} -weight 1
+    }
+    # disable longbutton if hardware doesn't support multi devices
+    set state normal
+    if {![expr [llength $audio_indevlist] > 1 && \
+        $multi>1 && [llength $audio_outdevlist] > 1]} {
+            set state disabled
+    }
+    $apifr.longbutton configure -state $state
+
+    # frame to encapsulate api-specific settings and devices,
+    # as well as the "Connect" button
+    set afr $mytoplevel.audio
+
+    destroy $afr
+    ttk::frame $afr
+    pack $afr -side top -fill x
+
+    # todo: put padding with style settings in dialog_prefs.tcl
+    set padx 1
+
+    # sample rate and advance
+    set sfr [ttk::labelframe $afr.settings -text [_ "Settings"] \
+        -style Prefs.TLabelframe -padding 5 ]
+    pack $sfr -side top -fill x -padx 3 -pady 10
+    ttk::label $sfr.l1 -text [_ "Sample rate"]
+    ttk::label $sfr.l2 -text [_ "Block size"]
+    ::dialog_prefs::dropdown $sfr.x2 \
+        ::audio_blocksize {64 128 256 512 1024 2048}
+    ttk::entry $sfr.x1 -textvariable audio_sr -width 7
+    ttk::label $sfr.l3 -text [_ "Delay (ms)"]
+    ttk::entry $sfr.x3 -textvariable audio_advance -width 7
+    grid $sfr.l1 -row 0 -sticky e -padx $padx
+    grid $sfr.x1 -row 0 -column 1 -sticky w -padx $padx
+    grid $sfr.l2 -row 0 -column 2 -sticky e -padx $padx
+    grid $sfr.x2 -row 0 -column 3 -sticky w -padx $padx
+    grid $sfr.l3 -row 1 -column 0 -sticky e -padx $padx
+    grid $sfr.x3 -row 1 -column 1 -sticky w -padx $padx
     if {$audio_callback >= 0} {
-        checkbutton $mytoplevel.srf.x4 -variable audio_callback \
-            -text [_ "Use callbacks"] -anchor e
-        pack $mytoplevel.srf.x4 -side left
-    }
-        # input device 1
-    frame $mytoplevel.in1f
-    pack $mytoplevel.in1f -side top
-
-    checkbutton $mytoplevel.in1f.x0 -variable audio_inenable1 \
-        -text [_ "Input device 1:"] -anchor e
-    button $mytoplevel.in1f.x1 -text [lindex $audio_indevlist $audio_indev1] \
-        -command [list audio_popup $mytoplevel $mytoplevel.in1f.x1 audio_indev1 $audio_indevlist]
-    label $mytoplevel.in1f.l2 -text [_ "Channels:"]
-    entry $mytoplevel.in1f.x2 -textvariable audio_inchan1 -width 3
-    pack $mytoplevel.in1f.x0 $mytoplevel.in1f.x1 $mytoplevel.in1f.l2 \
-        $mytoplevel.in1f.x2 -side left -fill x
-
-        # input device 2
-    if {$longform && $multi > 1 && [llength $audio_indevlist] > 1} {
-        frame $mytoplevel.in2f
-        pack $mytoplevel.in2f -side top
-
-        checkbutton $mytoplevel.in2f.x0 -variable audio_inenable2 \
-            -text [_ "Input device 2:"] -anchor e
-        button $mytoplevel.in2f.x1 -text [lindex $audio_indevlist $audio_indev2] \
-            -command [list audio_popup $mytoplevel $mytoplevel.in2f.x1 audio_indev2 \
-                $audio_indevlist]
-        label $mytoplevel.in2f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.in2f.x2 -textvariable audio_inchan2 -width 3
-        pack $mytoplevel.in2f.x0 $mytoplevel.in2f.x1 $mytoplevel.in2f.l2 \
-            $mytoplevel.in2f.x2 -side left -fill x
-    }
-
-        # input device 3
-    if {$longform && $multi > 1 && [llength $audio_indevlist] > 2} {
-        frame $mytoplevel.in3f
-        pack $mytoplevel.in3f -side top
-
-        checkbutton $mytoplevel.in3f.x0 -variable audio_inenable3 \
-            -text [_ "Input device 3:"] -anchor e
-        button $mytoplevel.in3f.x1 -text [lindex $audio_indevlist $audio_indev3] \
-            -command [list audio_popup $mytoplevel $mytoplevel.in3f.x1 audio_indev3 \
-                $audio_indevlist]
-        label $mytoplevel.in3f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.in3f.x2 -textvariable audio_inchan3 -width 3
-        pack $mytoplevel.in3f.x0 $mytoplevel.in3f.x1 $mytoplevel.in3f.l2 $mytoplevel.in3f.x2 -side left
-    }
-
-        # input device 4
-    if {$longform && $multi > 1 && [llength $audio_indevlist] > 3} {
-        frame $mytoplevel.in4f
-        pack $mytoplevel.in4f -side top
-
-        checkbutton $mytoplevel.in4f.x0 -variable audio_inenable4 \
-            -text [_ "Input device 4:"] -anchor e
-        button $mytoplevel.in4f.x1 -text [lindex $audio_indevlist $audio_indev4] \
-            -command [list audio_popup $mytoplevel $mytoplevel.in4f.x1 audio_indev4 \
-                $audio_indevlist]
-        label $mytoplevel.in4f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.in4f.x2 -textvariable audio_inchan4 -width 3
-        pack $mytoplevel.in4f.x0 $mytoplevel.in4f.x1 $mytoplevel.in4f.l2 \
-            $mytoplevel.in4f.x2 -side left
-    }
-
-        # output device 1
-    frame $mytoplevel.out1f
-    pack $mytoplevel.out1f -side top
-
-    checkbutton $mytoplevel.out1f.x0 -variable audio_outenable1 \
-        -text [_ "Output device 1:"] -anchor e
-    if {$multi == 0} {
-        label $mytoplevel.out1f.l1 \
-            -text [_ "(same as input device) ..............      "]
-    } else {
-        button $mytoplevel.out1f.x1 -text [lindex $audio_outdevlist $audio_outdev1] \
-            -command  [list audio_popup $mytoplevel $mytoplevel.out1f.x1 audio_outdev1 \
-                $audio_outdevlist]
-    }
-    label $mytoplevel.out1f.l2 -text [_ "Channels:"]
-    entry $mytoplevel.out1f.x2 -textvariable audio_outchan1 -width 3
-    if {$multi == 0} {
-        pack $mytoplevel.out1f.x0 $mytoplevel.out1f.l1 $mytoplevel.out1f.x2 -side left -fill x
-    } else {
-        pack $mytoplevel.out1f.x0 $mytoplevel.out1f.x1 $mytoplevel.out1f.l2\
-            $mytoplevel.out1f.x2 -side left -fill x
-    }
-
-        # output device 2
-    if {$longform && $multi > 1 && [llength $audio_outdevlist] > 1} {
-        frame $mytoplevel.out2f
-        pack $mytoplevel.out2f -side top
-
-        checkbutton $mytoplevel.out2f.x0 -variable audio_outenable2 \
-            -text [_ "Output device 2:"] -anchor e
-        button $mytoplevel.out2f.x1 -text [lindex $audio_outdevlist $audio_outdev2] \
-            -command \
-            [list audio_popup $mytoplevel $mytoplevel.out2f.x1 audio_outdev2 $audio_outdevlist]
-        label $mytoplevel.out2f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.out2f.x2 -textvariable audio_outchan2 -width 3
-        pack $mytoplevel.out2f.x0 $mytoplevel.out2f.x1 $mytoplevel.out2f.l2\
-            $mytoplevel.out2f.x2 -side left
-    }
-
-        # output device 3
-    if {$longform && $multi > 1 && [llength $audio_outdevlist] > 2} {
-        frame $mytoplevel.out3f
-        pack $mytoplevel.out3f -side top
-
-        checkbutton $mytoplevel.out3f.x0 -variable audio_outenable3 \
-            -text [_ "Output device 3:"] -anchor e
-        button $mytoplevel.out3f.x1 -text [lindex $audio_outdevlist $audio_outdev3] \
-            -command \
-            [list audio_popup $mytoplevel $mytoplevel.out3f.x1 audio_outdev3 $audio_outdevlist]
-        label $mytoplevel.out3f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.out3f.x2 -textvariable audio_outchan3 -width 3
-        pack $mytoplevel.out3f.x0 $mytoplevel.out3f.x1 $mytoplevel.out3f.l2 \
-            $mytoplevel.out3f.x2 -side left
-    }
-
-        # output device 4
-    if {$longform && $multi > 1 && [llength $audio_outdevlist] > 3} {
-        frame $mytoplevel.out4f
-        pack $mytoplevel.out4f -side top
-
-        checkbutton $mytoplevel.out4f.x0 -variable audio_outenable4 \
-            -text [_ "Output device 4:"] -anchor e
-        button $mytoplevel.out4f.x1 -text [lindex $audio_outdevlist $audio_outdev4] \
-            -command \
-            [list audio_popup $mytoplevel $mytoplevel.out4f.x1 audio_outdev4 $audio_outdevlist]
-        label $mytoplevel.out4f.l2 -text [_ "Channels:"]
-        entry $mytoplevel.out4f.x2 -textvariable audio_outchan4 -width 3
-        pack $mytoplevel.out4f.x0 $mytoplevel.out4f.x1 $mytoplevel.out4f.l2 \
-            $mytoplevel.out4f.x2 -side left
-    }
+        ttk::label $sfr.l4 -text [_ "Use callbacks"] -anchor e
+        ttk::checkbutton $sfr.x4 -variable audio_callback
+        grid $sfr.l4 -column 2 -row 1 -sticky e -padx $padx
+        grid $sfr.x4 -column 3 -row 1 -sticky w -padx $padx
+    }
+    grid columnconfigure $sfr {0 2} -weight 1
+    grid columnconfigure $sfr {1 3} -weight 2
+
+    # Devices 
+    set devfr [ttk::labelframe $afr.devs -text [_ "Devices"] \
+        -style Prefs.TLabelframe]
+    pack $devfr -side top -fill x -padx 3 -pady 10
+    set j 2
+    # todo: change in out to input output and make translatable strings
+    foreach {type name} [list in [_ "Input"] out [_ "Output"]] {
+        set domulti [expr $longform && $multi > 1 && \
+            [llength [set "audio_${type}devlist"]] > 1]
+        if {$domulti} {
+            ttk::label $devfr.$type \
+                -text [concat $name [_ "Devices"]]
+            ttk::label $devfr.${type}ch -text [_ "Channels"]
+            grid $devfr.$type -row $j -column 1 -padx $padx
+            grid $devfr.${type}ch -row $j -column 3 -padx $padx
+            incr j
+        } else {
+            if {$type eq "in"} {
+            ttk::label $devfr.$type \
+                -text [_ "Device Name"]
+            ttk::label $devfr.${type}ch -text [_ "Channels"]
+            grid $devfr.$type -row $j -column 1 -columnspan 2 -padx $padx
+            grid $devfr.${type}ch -row $j -column 3 -padx $padx
+            incr j
+            }
+        }
+        # Note: it'd be fairly easy to change the GUI to accommodate
+        # more than four devices, but Pd only takes and receives at most
+        # four devices, so the entire backend would have to change in order
+        # to do that
+        for {set i 0} {$i < 4} \
+            {incr i} {
+            set devno [expr $i + 1]
+            set row "$devfr.${type}$devno"
+            if {$domulti} {
+                set ctext "$devno."
+            } else {
+                set ctext $name
+            }
+            ttk::label ${row}x0 -text $ctext -anchor w
+            set ::audio_${type}dev${devno}label {}
+            ::dialog_prefs::dropdown_by_index ${row}x1 \
+                "::audio_${type}dev$devno" \
+                [concat [set audio_${type}devlist] None] \
+                "::audio_${type}dev${devno}label"
+            if {[set audio_${type}enable$devno] > 0} {
+                ::dialog_prefs::dropdown_set ${row}x1 [lindex [set audio_${type}devlist] [set audio_${type}dev$devno]]
+            } else {
+                ::dialog_prefs::dropdown_set ${row}x1 "None"
+                set audio_${type} [llength [set audio_${type}devlist]]
+            }
+            ttk::entry ${row}x2 -textvariable "audio_${type}chan$devno" -width 4
+            grid ${row}x0 -row $j -column 0 -sticky e -padx $padx
+            grid ${row}x1 -row $j -column 1 -columnspan 2 -sticky ew -padx $padx
+            grid ${row}x2 -row $j -column 3 -padx $padx
+            grid columnconfigure $afr.devs {1 2 3} -weight 2
+            grid columnconfigure $afr.devs 0 -weight 1
+            incr j
+            if {![expr $longform && $multi > 1 && \
+                [llength [set "audio_${type}devlist"]] > 1]} {
+                break
+            }
+        }
+    }
+    grid rowconfigure $devfr all -pad 3
+
+    # Connect button
+    ttk::frame $afr.buttonframe
+    pack $afr.buttonframe
+    pack $afr.buttonframe -side bottom
+    ttk::button $afr.buttonframe.apply -text [_ "Apply Audio Settings"]\
+        -command "::dialog_audio::apply $mytoplevel"
+    pack $afr.buttonframe.apply -side left -expand 1 -fill x \
+        -padx 15
 
-        # if not the "long form" but if "multi" is 2, make a button to
-        # restart with longform set. 
-    
-    if {$longform == 0 && $multi > 1} {
-        frame $mytoplevel.longbutton
-        pack $mytoplevel.longbutton -side top
-        button $mytoplevel.longbutton.b -text [_ "Use multiple devices"] \
-            -command  {pdsend "pd audio-properties 1"}
-        pack $mytoplevel.longbutton.b
-    }
-    $mytoplevel.srf.x1 select from 0
-    $mytoplevel.srf.x1 select adjust end
-    focus $mytoplevel.srf.x1
+#    $sfr.x1 select from 0
+#    $sfr.x1 select adjust end
+    focus $apifr.apilist
 }
